#ifndef SPI_H
#define SPI_H

#include <stdint.h>
#include "spi_config.h"
#include "spi_port_features.h"
#include "chip.h"

#define SPI_DMA_ENABLE  (SPI_PORT_SUPPORT_DMA && SPI_CFG_DMA_ENABLE)

struct st_spi_dev;

typedef enum {
    SPI_ERR_OK = 0,
    SPI_ERR_IFACE_NOT_ENABLED =  -3000,
    SPI_ERR_INVALID_IFACE_NUM =  -3001,
    SPI_ERR_UNSUP_DATA_LEN  =  -3002
} t_spi_err;

/** Флаги, характеризующие устройство */
typedef enum {
    SPI_FLAG_CPOL       = 0x00000001, /**< Полярность клока.  Если флаг установлен,
                                            то отсутствии обмена клок в 1, иначе - 0. */
    SPI_FLAG_CPHA       = 0x00000002, /**< Фаза колка. Если флаг установлен,
                                            то захват данных по второму перепаду клока (активный->неактивный),
                                            иначе - по первому (неактивный->aктивный) */
    SPI_FLAG_CS_HWCTL   = 0x00000004  /**< Если флаг установлен, то используется аппаратное
                                            управление CS и cs_pin должен соответствовать
                                            алетрнативной функции пина, иначе выполняется
                                            программное управление через GPIO, определяемым
                                            cs_pin. */
} t_spi_flags;

typedef void (*t_spi_dev_cb)(const struct st_spi_dev *dev);


/** Параметры SPI-интерфейса для работы с конкретным устройтсвом */
typedef struct st_spi_dev {
    uint8_t iface_num; /**< Номер интерфейса, к которому подключено устройства
                            (от 0, порт может определять константы для задания номера инетрфейса). */
    uint8_t wrdlen;    /**< Количество бит в одном слове при обмене по SPI. */
    t_chip_pin_id cs_pin; /**< Пин для генерации CS (соответствует альтернативной функции при
                              флаге #SPI_FLAG_CS_HWCTL, иначе - GPIO). */
    uint32_t baudrate; /**< Максимальная скорость передачи по SPI, поддерживаемая устройством, в Гц. */
    uint32_t flags;    /**< Набор флагов из #t_spi_flags. */
    t_spi_dev_cb exchange_start_cb; /**< Специальная callback-функция, вызываемая после
                                         настройки интерфейса перед активацией CS и началом обмена */
    t_spi_dev_cb exchange_finish_cb; /**< Специальная callback-функция, вызываемая
                                          после завершения обмена и деактивации CS */
} t_spi_dev;

/* Функции инициализации и деинициализации */

/** Начальная инициализация ресурсов для работы с устройством.
    Функция должна быть вызвана, перед вызовом любых других функций для работы
    с данным устройством.
    Если интерфейс SPI не был проинициализирован, то инициализируется также сам
    интерфейс (пины, активация клока)
    Также выполняется настройка пина CS, связанного с данным устройством */
t_spi_err spi_dev_init(const t_spi_dev *dev);

/** Завершение работы с устройством.
    Количество вызовов должно строго соответствовать количеству вызовов
    spi_dev_init с данным указателем.
    Если это последнее устройство, с которым была активная работа, то также
    зарещает работу самого порта SPI */
void spi_dev_close(const t_spi_dev *dev);


/** Принудительная настройка SPI в соответствии с параметрами указанного устройства.
    Как правило явно эту функцию вызывать не нужно, т.к. она вызывается автоматически
    в spi_exchange_exec_xxx(), spi_exchange_start() и spi_dma_start_exchange().
    Доступна публично на нештатный случай, если требуется одновременная работа с интерфейсом
    с помощью функций данного репозитория и внешнемы средставами. */
int spi_dev_activate(const t_spi_dev *dev);


/* Упрощенные функции для обмена данными с устройством.
 * Все действия по обмену заключены в одном вызове.
 * Позволяют вполнять только обмен заданного размера слов */

/** Обмен одним словом по SPI  с устройством (размер слова зависит от wrdlen устройства).
    Если SPI настроен на работу с другим устройством, то идет изменение конфигурации SPI.
    Выполняет активащию CS перед обменом и деактивацию после */
uint32_t spi_exchange_exec_word(const t_spi_dev *dev, uint32_t wrd);
/** Обмен массивом данных из фиксированного числа слов с устройстом.
    Количество байт, которое занимает каждое слово в массиве, зависит от wrdlen устройства
    (выравнивание на байт).
    Если SPI настроен на работу с другим устройством, то идет изменение конфигурации SPI.
    Выполняет активащию CS перед обменом и деактивацию после */
void spi_exchange_exec_array(const t_spi_dev *dev, const void *txbuf, void *rxbuf, uint32_t wrds_cnt, void (*cb_func)(void));



/* Более низкоуровневые функции для обмена.
   Начало и завершение обмена выполняются отдельными функциями, а сам обмен может
   быть выполнен за произвольное числов вызовов, что позволяет выполнять обмен,
   размер которого или передавемые данные зависят от принятых данных */

/** Начало обмена по SPI с указанным устройством. Происходит настройка параметров
 *  SPI для заданного устройства, а также активация CS для устройства */
void spi_exchange_start(const t_spi_dev *dev);
/** Завершение работы с устройством. Происходит деактивация CS устройства */
void spi_exchange_finish(const t_spi_dev *dev);
/** Обмен одиним словом по SPI. Функция аналогична spi_exchange_exec_word(),
    но предполагает внешнее управление началом и заверщением обмена, что позволяет
    вызвать ее несколько раз за один обмен. */
uint32_t spi_exchange_step_word(const t_spi_dev *dev, uint32_t wrd);
/** Обмен одиним массивом слов по SPI. Функция аналогична spi_exchange_exec_array(),
    но предполагает внешнее управление началом и заверщением обмена, что позволяет
    вызвать ее несколько раз за один обмен. */
void spi_exchange_step_array(const t_spi_dev *dev, const void *txbuf, void *rxbuf, uint32_t wrds_cnt, void (*cb_func)(void));

/* Функции работы с DMA, если поддержан портом (проект) */
#ifdef SPI_DMA_ENABLE
    typedef void (*t_spi_dma_done_cb)(void *data);

    /* Запуск обмена по SPI по DMA на size слов (размер слова зависит от wrdlen устройства).
       Завершение dma можно проверить через spi_dma_busy() или использовать
       spi_dma_start_exchange_cb(), вызывающую функцию по завершению.
       Как буфер на передачу, так и на прием должны быть действительны и не изменяться до завершения dma.
       В случае, если при запуске обмена предыдущий обмен не завершен, то функция блокируется
       и ожидает завершение предыдущего обмена */
    void spi_dma_start_exchange(const t_spi_dev *dev, const void *snd_wrds, void *rcv_wrds, uint32_t size);
    /* Аналогично spi_dma_start_exchange(), но позволяет указать функцию обратного вызова, которая
       будет вызвана из прерывания по завершению обмена. В функцию будет передан указатель
       на данные, переданных в параметре cb_data */
    void spi_dma_start_exchange_cb(const t_spi_dev *dev, const void *snd_wrds, void *rcv_wrds, uint32_t size,
                                   t_spi_dma_done_cb dma_done_cb, void *cb_data);
    /* Проверка, запущен ли незавершенный DMA для интерфейса SPI, которому принадлежит
       указанное устройство (1 - запущен, 0 - нет обмена) */
    int spi_dma_busy(const t_spi_dev *dev);
#endif


#endif // SPI_H

